SystemOrganization addCategory: #ConfigurationOfXtreams!

Object subclass: #ConfigurationOfXtreams
	instanceVariableNames: 'project originalUnderscoreSelectorsPreferenceValue'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfXtreams'!

!ConfigurationOfXtreams commentStamp: 'ul 2/23/2011 06:41' prior: 0!
Metacello configuration of Xtreams.

http://code.google.com/p/metacello/
http://code.google.com/p/xtreams/!

!ConfigurationOfXtreams class methodsFor: 'development support' stamp: 'ul 2/21/2011 04:29'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfXtreams class methodsFor: 'private' stamp: 'ul 2/21/2011 04:29'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfXtreams class methodsFor: 'private' stamp: 'fbs 4/14/2012 18:40'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := (MCCacheRepository default includesVersionNamed: aString)
		ifTrue: [MCCacheRepository default]
		ifFalse: [MCHttpRepository
				location: aPath
				user: ''
				password: ''].
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfXtreams class methodsFor: 'private' stamp: 'fbs 4/14/2012 18:40'!
ensureMetacello
	"Bootstrap Gofer (if necessary), load latest mcz file for ConfigurationOfMetacello (using old 
	 Gofer API), then load the latest version of Metacello itself."
	| meta |
	meta := 'ConfigurationOfMetacello-dkh.674'.
	Smalltalk at: #MetacelloProject ifAbsent: [
		"list of repositories to try, in case primary repository is not accessible"
		self bootstrapPackage: meta from: 'http://www.squeaksource.com/MetacelloRepository'.
		Smalltalk at: #ConfigurationOfMetacello ifPresent: [:config | config load].
		Smalltalk at: #MetacelloProject ifAbsent: [
			self bootstrapPackage: meta from: 'http://seaside.gemstone.com/ss/metacello'.
			Smalltalk at: #ConfigurationOfMetacello ifPresent: [:config | config load].
			Smalltalk at: #MetacelloProject ifAbsent: [self error: 'Couldn''t load Metacello']]].! !

!ConfigurationOfXtreams class methodsFor: 'private' stamp: 'fbs 4/14/2012 18:40'!
ensureMetacelloBaseConfiguration
	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self bootstrapPackage: 'Metacello-Base-DaleHenrichs.19' from: 'http://seaside.gemstone.com/ss/metacello']! !

!ConfigurationOfXtreams class methodsFor: 'metacello tool support' stamp: 'ul 2/21/2011 04:29'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfXtreams class methodsFor: 'loading' stamp: 'ul 2/21/2011 04:29'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfXtreams class methodsFor: 'loading' stamp: 'ul 2/21/2011 04:29'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfXtreams class methodsFor: 'loading' stamp: 'ul 2/21/2011 04:29'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfXtreams class methodsFor: 'accessing' stamp: 'ul 2/21/2011 04:29'!
project

	^self new project! !

!ConfigurationOfXtreams class methodsFor: 'development support' stamp: 'ul 2/21/2011 04:29'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfXtreams methodsFor: 'baselines' stamp: 'ul 2/21/2011 05:14'!
baseline100: spec 
	<version: '1.0-baseline'>
        
	spec for: #common do: [
                spec blessing: #baseline ].

	spec for: #squeakCommon do: [
		spec repository: 'http://www.squeaksource.com/Xtreams'.
		spec project: 'FFI' with: [
			spec
				className: 'ConfigurationOfFFI';
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'Xtreams-Support';
			package: 'Xtreams-Core';
			package: 'Xtreams-Terminals';
			package: 'Xtreams-Transforms';
			package: 'Xtreams-Substreams';
			package: 'Xtreams-Parsing';
			" --- tests follow --- "
			package: 'Xtreams-CoreTests' with: [ spec requires: 'Xtreams-Core' ];
			package: 'Xtreams-TerminalsTests' with: [ spec requires: 'Xtreams-Terminals' ];
			package: 'Xtreams-TransformsTests' with: [ spec requires: 'Xtreams-Transforms' ];
			package: 'Xtreams-SubstreamsTests' with: [ spec requires: 'Xtreams-Substreams' ];
			package: 'Xtreams-ParsingTests' with: [ spec requires: 'Xtreams-Parsing' ];
			" --- following require FFI --- "
			package: 'Xtreams-Xtras' with: [
				spec 
					requires: #('FFI') ];
			package: 'Xtreams-XtrasTests' with: [ spec requires: 'Xtreams-Xtras' ].
		spec
			group: 'default' with: #('Full Tests');
			group: 'Core' with: #(
				'Xtreams-Support'
				'Xtreams-Core'
				'Xtreams-Terminals'
				'Xtreams-Transforms'
				'Xtreams-Substreams'
				'Xtreams-Parsing');
			group: 'Tests' with: #(
				'Xtreams-CoreTests'
				'Xtreams-TerminalsTests'
				'Xtreams-TransformsTests'
				'Xtreams-SubstreamsTests'
				'Xtreams-ParsingTests');
			group: 'Full' with: #('Core' 'Xtreams-Xtras');
			group: 'Full Tests' with: #('Full' 'Tests' 'Xtreams-XtrasTests') ].
		
	spec for: #squeak do: [
		spec package: 'Xtreams-Xtras' with: [
			spec 
				requires: #('FFI');
				preLoadDoIt: #preLoadSqueakEnsureGlobalUnderscoreSelectors;
				postLoadDoIt: #postLoadSqueakRestoreGlobalUnderscoreSelectors ] ]! !

!ConfigurationOfXtreams methodsFor: 'baselines' stamp: 'DaleHenrichs 03/12/2011 22:23'!
baseline101: spec 
	<version: '1.1-baseline'>
        
	spec for: #common do: [
                spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/Xtreams'.
		spec 
			package: 'Xtreams-Support';
			package: 'Xtreams-Core';
			package: 'Xtreams-Terminals';
			package: 'Xtreams-Transforms';
			package: 'Xtreams-Substreams';
			package: 'Xtreams-CoreTests' with: [ spec requires: 'Xtreams-Core' ];
			package: 'Xtreams-TerminalsTests' with: [ spec requires: 'Xtreams-Terminals' ];
			package: 'Xtreams-TransformsTests' with: [ spec requires: 'Xtreams-Transforms' ];
			package: 'Xtreams-SubstreamsTests' with: [ spec requires: 'Xtreams-Substreams' ].
		spec
			group: 'default' with: #('Full Tests');
			group: 'Core' with: #(
				'Xtreams-Support'
				'Xtreams-Core'
				'Xtreams-Terminals'
				'Xtreams-Transforms'
				'Xtreams-Substreams'
				);
			group: 'Tests' with: #(
				'Xtreams-CoreTests'
				'Xtreams-TerminalsTests'
				'Xtreams-TransformsTests'
				'Xtreams-SubstreamsTests'
				);
			group: 'Full' with: #('Core');
			group: 'Full Tests' with: #('Full' 'Tests') ].
	spec for: #squeakCommon do: [
		spec project: 'FFI' with: [
			spec
				className: 'ConfigurationOfFFI';
				repository: 'http://www.squeaksource.com/MetacelloRepository'].
		spec
			package: 'Xtreams-Parsing';
			package: 'Xtreams-ParsingTests' with: [ spec requires: 'Xtreams-Parsing'];
			package: 'Xtreams-Xtras' with: [
				spec 
					requires: #('FFI') ];
			package: 'Xtreams-XtrasTests' with: [ spec requires: 'Xtreams-Xtras' ].
		spec
			group: 'Core' with: #('Xtreams-Parsing');
			group: 'Tests' with: #('Xtreams-ParsingTests');
			group: 'Full' with: #('Xtreams-Xtras');
			group: 'Full Tests' with: #('Xtreams-XtrasTests') ].
	spec for: #gemstone do: [
		spec 
			package: 'Xtreams-Support' with: [
				spec file: 'Xtreams-Support.gemstone'];
			package: 'Xtreams-Terminals' with: [
				spec file: 'Xtreams-Terminals.gemstone'];
			package: 'Xtreams-TerminalsTests' with: [
				spec file: 'Xtreams-TerminalsTests.gemstone'];
			yourself.
	].
	spec for: #squeak do: [
		spec package: 'Xtreams-Xtras' with: [
			spec 
				requires: #('FFI');
				preLoadDoIt: #preLoadSqueakEnsureGlobalUnderscoreSelectors;
				postLoadDoIt: #postLoadSqueakRestoreGlobalUnderscoreSelectors ] ]! !

!ConfigurationOfXtreams methodsFor: 'symbolic versions' stamp: 'nice 3/4/2012 17:32'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1'.
	spec for: #'squeakCommon' version: '1.2dev'.
! !

!ConfigurationOfXtreams methodsFor: 'doits' stamp: 'ul 2/21/2011 04:59'!
postLoadSqueakRestoreGlobalUnderscoreSelectors 

	Scanner prefAllowUnderscoreSelectors: originalUnderscoreSelectorsPreferenceValue! !

!ConfigurationOfXtreams methodsFor: 'doits' stamp: 'ul 2/21/2011 05:08'!
preLoadSqueakEnsureGlobalUnderscoreSelectors

	originalUnderscoreSelectorsPreferenceValue := Scanner prefAllowUnderscoreSelectors.
	Scanner prefAllowUnderscoreSelectors: true.
	$_ tokenish ifFalse: [
		Character
			compile: 'tokenish
		"Answer whether the receiver is a valid token-character--letter, digit, or
		colon."

		^self == $_ or: [self == $: or: [self isLetter or: [self isDigit]]]'
			classified: 'testing'.
		String initialize ].! !

!ConfigurationOfXtreams methodsFor: 'accessing' stamp: 'fbs 4/15/2012 12:14'!
project

	^ project ifNil: [ | projectAttributes |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		project := (Smalltalk at: #MetacelloMCProject) new.
		projectAttributes := #().
		"Smalltalk at: #SystemVersion ifPresent: [:cl | | versionString |
			versionString := cl current version.
			((versionString beginsWith: 'Pharo-1.0') or: [versionString beginsWith: 'PharoCore1.0'])
				ifTrue: [ projectAttributes := projectAttributes, #() ] ]."
		project projectAttributes:  projectAttributes.
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear ]! !

!ConfigurationOfXtreams methodsFor: 'symbolic versions' stamp: 'nice 3/4/2012 17:44'!
stable: spec 
	<symbolicVersion: #stable>

"NOTE: At the time of writing, Metacello cannot load a #stable version because there is no #stable ConfigurationOfFFI...
And the error message is not helpful..."

	spec
		for: #'gemstone' version: '1.1';
		for: #'squeak4.4.x' version: '1.2';
		for: #'squeak4.3.x' version: '1.2';
		for: #'squeak4.2.x' version: '1.0';
		for: #'pharo1.4.x' version: '1.2';
		for: #'pharo1.3.x' version: '1.2';
		for: #'pharo1.2.x' version: '1.0'

! !

!ConfigurationOfXtreams methodsFor: 'versions' stamp: 'ul 2/22/2011 08:11'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>

	spec for: #common do: [
		spec blessing: #developement.
		spec author: 'Levente Uzonyi'.
		spec description: 'A stable, but not release version' ].
	
	spec for: #squeakCommon do: [
		spec project: 'FFI' with: '1.4'.
		
		spec
			package: 'Xtreams-Support' with: 'Xtreams-Support-MartinKobetic.7';
			package: 'Xtreams-Core' with: 'Xtreams-Core-MartinKobetic.13';
			package: 'Xtreams-Terminals' with: 'Xtreams-Terminals-MartinKobetic.22';
			package: 'Xtreams-Transforms' with: 'Xtreams-Transforms-MartinKobetic.16';
			package: 'Xtreams-Substreams' with: 'Xtreams-Substreams-MartinKobetic.13';
			package: 'Xtreams-Parsing' with: 'Xtreams-Parsing-Martin Kobetic.2'.

		spec
			package: 'Xtreams-CoreTests' with: 'Xtreams-CoreTests-MartinKobetic.14';
			package: 'Xtreams-TerminalsTests' with: 'Xtreams-TerminalsTests-MartinKobetic.11';
			package: 'Xtreams-TransformsTests' with: 'Xtreams-TransformsTests-MartinKobetic.8';
			package: 'Xtreams-SubstreamsTests' with: 'Xtreams-SubstreamsTests-MartinKobetic.8';
			package: 'Xtreams-ParsingTests' with: 'Xtreams-ParsingTests-nice.1'.

		spec
			package: 'Xtreams-Xtras' with: 'Xtreams-Xtras-ul.21';
			package: 'Xtreams-XtrasTests' with: 'Xtreams-XtrasTests-MartinKobetic.3' ]! !

!ConfigurationOfXtreams methodsFor: 'versions' stamp: 'nice 3/4/2012 17:30'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '- GemStone port
- tweak GemStone support'.
		spec author: 'dkh'.
		spec timestamp: '03/14/2011 12:30:49'.
		spec 
			package: 'Xtreams-Core' with: 'Xtreams-Core-DaleHenrichs.14';
			package: 'Xtreams-Transforms' with: 'Xtreams-Transforms-DaleHenrichs.17';
			package: 'Xtreams-Substreams' with: 'Xtreams-Substreams-DaleHenrichs.14';
			package: 'Xtreams-CoreTests' with: 'Xtreams-CoreTests-DaleHenrichs.16';
			package: 'Xtreams-TransformsTests' with: 'Xtreams-TransformsTests-DaleHenrichs.10';
			package: 'Xtreams-SubstreamsTests' with: 'Xtreams-SubstreamsTests-DaleHenrichs.9'. ].

	spec for: #'squeakCommon' do: [
		spec project: 'FFI' with: '1.4'.
		spec 
			package: 'Xtreams-Parsing' with: 'Xtreams-Parsing-Martin Kobetic.2';
			package: 'Xtreams-ParsingTests' with: 'Xtreams-ParsingTests-nice.1';
			package: 'Xtreams-Support' with: 'Xtreams-Support-MartinKobetic.7';
			package: 'Xtreams-Terminals' with: 'Xtreams-Terminals-MartinKobetic.22';
			package: 'Xtreams-TerminalsTests' with: 'Xtreams-TerminalsTests-MartinKobetic.11';
			package: 'Xtreams-Xtras' with: 'Xtreams-Xtras-ul.21';
			package: 'Xtreams-XtrasTests' with: 'Xtreams-XtrasTests-MartinKobetic.3'. ].

	spec for: #'gemstone' do: [
		spec 
			package: 'Xtreams-Support' with: 'Xtreams-Support.gemstone-dkh.11';
			package: 'Xtreams-Terminals' with: 'Xtreams-Terminals.gemstone-DaleHenrichs.24';
			package: 'Xtreams-TerminalsTests' with: 'Xtreams-TerminalsTests.gemstone-dkh.12'. ].
! !

!ConfigurationOfXtreams methodsFor: 'versions' stamp: 'nice 3/4/2012 23:57'!
version12: spec
	<version: '1.2' imports: #('1.1-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Nicolas Cellier'.
		spec description: 'A stable release' ].
	
	spec for: #squeakCommon do: [
		spec project: 'FFI' with: '1.5'.
		
		spec
			package: 'Xtreams-Support' with: 'Xtreams-Support-nice.10';
			package: 'Xtreams-Core' with: 'Xtreams-Core-nice.18';
			package: 'Xtreams-Terminals' with: 'Xtreams-Terminals-nice.27';
			package: 'Xtreams-Transforms' with: 'Xtreams-Transforms-nice.21';
			package: 'Xtreams-Substreams' with: 'Xtreams-Substreams-nice.16';
			package: 'Xtreams-Parsing' with: 'Xtreams-Parsing-Martin Kobetic.2'.

		spec
			package: 'Xtreams-CoreTests' with: 'Xtreams-CoreTests-nice.19';
			package: 'Xtreams-TerminalsTests' with: 'Xtreams-TerminalsTests-nice.14';
			package: 'Xtreams-TransformsTests' with: 'Xtreams-TransformsTests-nice.11';
			package: 'Xtreams-SubstreamsTests' with: 'Xtreams-SubstreamsTests-nice.10';
			package: 'Xtreams-ParsingTests' with: 'Xtreams-ParsingTests-nice.1'.

		spec
			package: 'Xtreams-Xtras' with: 'Xtreams-Xtras-MartinKobetic.23';
			package: 'Xtreams-XtrasTests' with: 'Xtreams-XtrasTests-MartinKobetic.3' ]! !

!ConfigurationOfXtreams methodsFor: 'versions' stamp: 'nice 3/4/2012 17:32'!
version12dev: spec
	<version: '1.2dev' imports: #('1.2')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'Nicolas Cellier'.
		spec description: 'The development branch - same as release now' ].
	! !
